<style>
  .CarrierList {
    border-bottom: 1px dashed #eee;
    padding-bottom: 5px;
    margin-bottom: 5px;
  }

  .CarrierList span {
    display: inline-block;
    margin-right: 10px;
  }

</style>
<template>
  <div class="VehicleManagement">
    <div class="head-title">
      楼宇管理
      <div>
        <el-button @click="checkAll=false,dialogVisible = true" style="float: right; margin-top: -25px" size="small"
          type="primary">
          批量导出
        </el-button>
      </div>
      <div>
        <el-button type="primary" style="float: right; margin: -25px 10px 0px 0px" class="el-button--small"
          @click="CommonJump('tenementVehicle')">新增楼宇</el-button>
      </div>
    </div>
    <div class="content">
      <div>
        <div class="searchInput" style="width: 250px; margin-bottom: 10px">
          <el-input @keyup.enter.native="(msg.pageIndex = 1), getList()" @clear="(msg.pageIndex = 1), getList()"
            style="display: inline-block; width: 225px; height: 30px" placeholder="楼宇名称" v-model="msg.Name"
            size="small" clearable>
          </el-input>
          <span @click="(msg.pageIndex = 1), getList()" class="el-icon-search" style="
              color: #979dad;
              font-size: 14px;
              position: relative;
              top: 1px;
            "></span>
        </div>
        <div class="searchInput" style="width: 250px; margin-bottom: 10px">
          <el-input @keyup.enter.native="(msg.pageIndex = 1), getList()" @clear="(msg.pageIndex = 1), getList()"
            style="display: inline-block; width: 225px; height: 30px" placeholder="地址" v-model="msg.Address"
            size="small" clearable>
          </el-input>
          <span @click="(msg.pageIndex = 1), getList()" class="el-icon-search" style="
              color: #979dad;
              font-size: 14px;
              position: relative;
              top: 1px;
            "></span>
        </div>
        <div class="searchInput" style="width: 200px; margin-bottom: 10px">
          <el-select size="small" v-model="msg.CategoryId" filterable
            @change="(msg.pageIndex = 1), getList()" placeholder="请选择楼宇等级">
            <el-option v-for="item in CategoryList" :key="item.ID" :label="item.ClassName" :value="item.ID">
            </el-option>
          </el-select>
        </div>
        <!-- <div class="searchInput" style="width: 200px; margin-bottom: 10px">
          <el-select size="small" v-model="msg.OpeningStatus" filterable
            @change="(msg.pageIndex = 1), getList()" placeholder="请选择状态">
            <el-option v-for="item in OpeningList" :key="item.Id" :label="item.Name" :value="item.Id">
            </el-option>
          </el-select>
        </div>
        <el-date-picker class="indataPicker" type="daterange" v-model="dateStr" range-separator="至"
          start-placeholder="运营日期" end-placeholder="运营日期" size="small" @change="getList" value-format="yyyy-MM-dd">
        </el-date-picker> -->

      </div>
      <el-table :data="tableData" v-loading="loading" border style="width: 100%; margin: 20px 0">
        <el-table-column prop="Name" width="200" label="楼宇名称">
        </el-table-column>
        <el-table-column prop="" width="100" label="封面">
          <template slot-scope="scope">
            <el-image v-if="scope.row.CoverImg" :src="scope.row.CoverImg" style="width: 50px"
            :preview-src-list="scope.row.LogoList">
            </el-image>
          </template>
        </el-table-column>
        <el-table-column prop="Address" width="200" label="楼宇位置">
        </el-table-column>
        <el-table-column prop="ConstructionTime" width="180" label="建设时间">
        </el-table-column>
        <el-table-column prop="OperationTime" width="180" label="投运时间">
        </el-table-column>
        <el-table-column prop="" min-width="200" label="楼宇等级">
          <template slot-scope="scope">
            {{ scope.row.CategoryName }}
          </template>
        </el-table-column>
        <el-table-column prop="IsRecommend" label="是否推荐" width="100">
          <template slot-scope="scope">
            <el-switch
              v-model="scope.row.IsRecommend"
              :active-value="1"
              :inactive-value="0"
              @change="changeRecommend(scope.row, $event)">
            </el-switch>
          </template>
        </el-table-column>
        <el-table-column prop="BuildingNum" width="" label="楼栋数量">
        </el-table-column>
        <el-table-column prop="FloorNum" width="" label="楼层量">
        </el-table-column>
        <el-table-column prop="Developers" width="200" label="开发商">
        </el-table-column>
        <el-table-column prop="SaleOrSelf" width="120" label="销售/自持比例">
        </el-table-column>
        <el-table-column prop="" width="110" label="是否统一运营">
          <template slot-scope="scope">
            {{scope.row.IsAllOperate?'是':'否'}}
          </template>
        </el-table-column>
        <el-table-column prop="PropertyFee" width="130" label="物业费(元)㎡/月">
        </el-table-column>
        <el-table-column prop="RentFee" width="140" label="月租金(元)㎡/月">
        </el-table-column>

        <el-table-column prop="" width="200" label="楼负责人">
          <template slot-scope="scope">
            <div>
              {{scope.row.ContactName}}
            </div>
            <div>
              {{scope.row.ContactPhone}}
            </div>
          </template>
        </el-table-column>

        <el-table-column label="操作" width="100" fixed="right">
          <template slot-scope="scope">
            <el-tooltip class="item" effect="dark" content="修改" placement="top">
              <img @click="CommonJump('tenementVehicle', { ID: scope.row.BuildId})"
                src="../../assets/img/userman/edit.png" alt="" />
            </el-tooltip>
            <el-tooltip class="item" effect="dark" content="删除" placement="top">
              <img @click="delManage(scope.row)" src="../../assets/img/userman/del.png" alt="" />
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>
      <el-pagination style="text-align: right" background @current-change="handleCurrentChange"
        :page-size="msg.pageSize" :current-page.sync="msg.pageIndex" layout="total,prev, pager, next" :total="total">
      </el-pagination>
    </div>

    <!-- 选择导出信息 -->
    <el-dialog title="选择导出信息" :visible.sync="dialogVisible" width="960px">
      <div v-loading="downLoadLoading" :element-loading-text="loadingText">
        <el-form style="border: 1px solid #f0f2f7" :model="addMsg" ref="addMsg" label-width="100px">
          <div style="
            box-sizing: border-box;
            background-color: #f3f5f6;
            width: 100%;
            padding-left: 20px;
            height: 50px;
            line-height: 50px;
          ">
            <el-checkbox :indeterminate="isIndeterminate" v-model="checkAll" @change="handleCheckAllChange">全选
            </el-checkbox>
          </div>
          <div style="margin: 15px 0"></div>
          <div style="padding: 10px 25px 20px">
            <el-checkbox-group v-model="checkedCities" @change="handleCheckedCitiesChange">
              <el-checkbox style="margin-bottom: 10px; width: 135px" v-for="city in cities" :label="city.Id"
                :key="city.Name">
                {{ city.Name }}</el-checkbox>
            </el-checkbox-group>
          </div>
        </el-form>
        <div style="text-align: right; margin-top: 20px">
          <el-button size="small" type="primary" @click="downLoadCarrier">导出</el-button>
        </div>
      </div>
    </el-dialog>
  </div>
</template>
<script>
  import {
    setInterval,
    clearInterval
  } from 'timers';
  export default {
    data() {
      return {
        msg: {
          pageIndex: 1,
          pageSize: 15,
          Name: "", //名称
          Address: "", //地址
          CategoryId: 0, //分类Id
        },
        usermsg: {
          pageIndex: 1,
          pageSize: 20,
          Name: '',
          Source: 0,
          MemberGrade: 0,
          Id: 0,
          Moblie: ''
        },
        userList: [],
        addMsg: {},
        dialogVisible: false,
        dateStr: [], //日期
        total: 0,
        tableData: [], //数据列表
        isShowAdd: false, //新增修改载体
        ProjectTypeList: [], //项目类型
        checkAll: false,
        checkedCities: [],
        cities: [],
        cityOptions: [],
        isIndeterminate: false,
        downLoadLoading: false, //导出Loading
        download_timer: null, //下载文件timer
        loadingText: "", //下载文件提示名称
        CategoryList: [],
        ShopTypeList: [{
            Name: '成都首店',
            Id: 1
          },
          {
            Name: '宜宾商载通',
            Id: 2
          },
        ],
        OpeningList: [{
            Name: '不限',
            Id: -1
          },
          {
            Name: '即将投运',
            Id: 0
          },
          {
            Name: '已投运',
            Id: 1
          },
        ]
      };
    },
    created() {
      this.getList();
      this.getTypeEnumList();
      this.getDown();
      this.getuserList()
    },
    watch: {
      $route: {
        handler(val, oldVal) {

        },
        deep: true,
      },
    },
    methods: {
      ChangeListName(val) {
        this.usermsg.Name = val;
        this.getuserList();
      },
      getuserList() {
        this.apipost("/api/user/GetMemberUserDropDownList", this.usermsg, res => {
          if (res.data.resultCode == 1) {
            let pageData = res.data.data.pageData;
            this.userList = pageData;
          }
        })
      },
      getList() {
        this.loading = true;
        // if (this.dateStr && this.dateStr.length > 0) {
        //   this.msg.QStartDate = this.dateStr[0];
        //   this.msg.QEndDate = this.dateStr[1];
        // } else {
        //   this.msg.QStartDate = "";
        //   this.msg.QEndDate = "";
        // }
        this.apipost("/api/YBTrade/GetBuildingPage", this.msg, (res) => {
          this.loading = false;
          if (res.data.resultCode == 1) {
            this.total = res.data.data.count;
            let pageData = res.data.data.pageData;
            this.tableData = pageData;
            this.tableData.forEach((x) => {
              x.LogoList = [];
              x.LogoList.push(x.CoverImg);
            });
          }
        });
      },
      handleCheckAllChange(val) {
        this.checkedCities = val ? this.cityOptions : [];
        this.isIndeterminate = false;
      },
      handleCheckedCitiesChange(value) {
        let checkedCount = value.length;
        this.checkAll = checkedCount === this.cities.length;
        this.isIndeterminate =
          checkedCount > 0 && checkedCount < this.cities.length;
      },
      //下载载体文件
      downLoadCarrier() {
        this.msg.ExcelEnumIds = this.checkedCities;
        let msg = JSON.parse(JSON.stringify(this.msg));
        msg.RandomNum = Math.random();
        if (!msg.Id || msg.Id == "") {
          msg.Id = 0;
        }
        this.downLoadLoading = true;
        this.loadingText = "正在生成楼宇文件,请勿关闭或刷新页面...";
        var that = this;
        this.download_timer = setInterval(function () {
          that.checkCarrierFile(msg)
        }, 2000);
      },
      checkCarrierFile(msg) {
        var fileName = "楼宇信息.xls";
        var that = this;
        this.apipost(
          "/api/YBTrade/CheckBuildingFile",
          msg,
          (res) => {
            if (res.data.resultCode == 1) {
              clearInterval(this.download_timer);
              this.checkedCities = [];
              this.loadingText = "正在下载楼宇文件,请勿关闭或刷新页面...";
              var fileUrl = res.data.data.fileUrl;
              var filepath = res.data.data.filePath;
              var key = res.data.message;
              var params = {
                fileUrl: fileUrl
              }
              //删除缓存和Key
              var deleteparams = {
                key: key,
                fileUrl: fileUrl,
                filepath: filepath,
              };
              var apiurl = that.domainManager().DomainUrl + "/api/Trade/GetFile";
              var postData = that.GetPostData("", params, "");
              that.$http.post(apiurl, postData, {
                responseType: 'arraybuffer',
                onDownloadProgress: (progressEvent) => {
                  const progress = Math.round((progressEvent.loaded / progressEvent.total) * 100);
                  that.loadingText = `正在下载【` + "楼宇" + `】文件` + progress +
                    `%,请勿关闭或刷新页面...`;
                  // 在这里处理下载进度, 如更新界面上的进度条
                }
              }).then((res) => {
                let blob = new Blob([res.data], {
                  type: "application/vnd.ms-excel"
                })
                let url = URL.createObjectURL(blob);
                let link = document.createElement('a');
                link.href = url;
                link.setAttribute("download", fileName);
                document.body.appendChild(link);
                link.click();
                that.downLoadLoading = false;
                that.loadingText = "";
                that.apipost("/api/Trade/DeleteKey", deleteparams, (res) => {})
                that.dialogVisible = false;
              }).catch(function (res) {
                console.log(res);
              });
            }
          }
        );
      },

      getDown() {
        this.cityOptions = [];
        this.apipost("/api/YBTrade/GetBuildingExportEnumList", {}, (res) => {
          this.cities = res.data.data;
          let data = res.data.data;
          data.forEach((item) => {
            this.cityOptions.push(item.Id);
          });
        });
      },

      //删除
      delManage(obj) {
        let that = this;
        that.Confirm("是否删除?", function () {
          that.apipost(
            "/api/YBTrade/RemoveBuildingInfo", {
              BuildId: obj.BuildId,
            },
            (res) => {
              if (res.data.resultCode == 1) {
                that.Success(res.data.message);
                that.getList();
              } else {
                that.Error(res.data.message);
              }
            }
          );
        });
      },
      handleCurrentChange(val) {
        this.msg.pageIndex = val;
        this.getList();
      },
      //获取项目类型
      getTypeEnumList() {
        this.apipost("/api/Trade/GetProjectTypeEnumList", {}, (res) => {
          if (res.data.resultCode == 1) {
            this.ProjectTypeList = res.data.data;
          }
        });
        this.apipost("/api/Trade/GetBrandClassList", {
          BrandCategory: 2
        }, (res) => {
          if (res.data.resultCode == 1) {
            this.CategoryList = res.data.data;
            let obj = {
              ClassName: "不限",
              ID: 0,
            };
            this.CategoryList.unshift(obj);
          }
        });
      },

      //获取项目类型
      getProject(type) {
        let str = "";
        this.ProjectTypeList.forEach((x) => {
          if (x.Id == type) {
            str = x.Name;
          }
        });
        return str;
      },
      //推荐/取消推荐
      changeRecommend(row, val) {
        let msg = {
          BuildId: row.BuildId,
          IsRecommend: val,
        };
        this.apipost("/api/YBTrade/RecommendBuildingInfo", msg, (res) => {
          if (res.data.resultCode == 1) {
            this.Success(res.data.message);
            this.getList();
          } else {
            this.Error(res.data.message);
          }
        });
      },
    },
    mounted() {},
  };

</script>
<style>
  .VehicleManagement .content .searchInput {
    border: 1px solid #dcdfe6;
    border-radius: 4px;
  }

  .VehicleManagement .content .searchInput .el-input__inner {
    border: none;
    outline: none;
    height: 30px;
    line-height: 30px;
  }

  .VehicleManagement .content .searchInput {
    line-height: normal;
    display: inline-table;
    width: 100%;
    border-collapse: separate;
    border-spacing: 0;
    width: 250px;
    margin-right: 20px;
  }

  .VehicleManagement .content {
    background: #fff;
    margin-top: 10px;
    padding: 20px;
    box-sizing: border-box;
  }

</style>
